#ifndef __UTIL_H__
#define __UTTL_H__

#include <sys/types.h>

#include <credentials/certificates/certificate.h>
#include <credentials/certificates/x509.h>
#include <credentials/keys/private_key.h>

#include <chunk.h>

void *abac_xmalloc(size_t size);
void *abac_xrealloc(void *ptr, size_t size);
char *abac_xstrdup(char *source);
char *abac_trim_quotes(char *string);
void abac_split(char *string, char *delim, char **ret, int *num);
int abac_validate_clean_name(char *string);
int abac_validate_clean_aspect_name(char *string);
chunk_t abac_generate_serial();
void abac_errx(int,char*);

#ifdef DEBUG
#define debug_printf(...) fprintf(stderr, __VA_ARGS__)
#else
#define debug_printf(...) do { } while (0)
#endif

#endif /* __UTIL_H__ */
